(library (tprogram)
  (export Trex? Trex-case
          Ref Quote Primref PrimrefWrap Set App If CaseLambda Seq
          Letrec Trex-CaseLambdaClause-case CaseLambdaClause)
  (import (rnrs) (datatype) (idents))

(define-datatype (Trex-CaseLambdaClause)
  (CaseLambdaClause (formals (improper-list-of ident?)) (body Trex?)))

(define-datatype (Trex)
  (Ref src (id ident?))
  (Quote src obj)
  (Primref src (safe boolean?) prim-identifier)
  (PrimrefWrap (primref Trex?) (expr Trex?)) ;; Used by benchmarking code
  (Set src (id ident?) (expr Trex?))
  (App src (expr Trex?) (expr* (list-of Trex?)))
  (If src (test Trex?) (thn Trex?) (els Trex?))
  (CaseLambda src (clause* (list-of Trex-CaseLambdaClause?)))
  (Seq src (expr1 Trex?) (expr2 Trex?))
  (Letrec src (id* (list-of ident?)) (expr* (list-of Trex?)) (body Trex?)))

)
